#region Copyright Syncfusion Inc. 2001-2015.
// Copyright Syncfusion Inc. 2001-2015. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using Microsoft.LightSwitch.Threading;
using System;
using System.IO;
using System.Net;
using System.Runtime.InteropServices.Automation;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace LightSwitchApplication
{
    public class Helper
    {
        #region Contants
        public const string BinaryWordDocument = "Word Binary Documents (*.doc)|*.doc";
        public const string WordDocument = "Word Documents (*.docx)|*.docx";
        public const string BinaryExcelWorksheets = "Excel Binary Worksheets (*.xls)|*.xls";
        public const string ExcelWorksheets = "Excel Worksheets (*.xlsx)|*.xlsx";
        #endregion

        #region Helper Methods
        /// <summary>
        /// Display the File Dialog based on the Application Type.
        /// </summary>
        /// <param name="eventHandler">This event is occuren once the file diloag is closed.</param>
        public static void ShowSaveDialog(EventHandler eventHandler)
        {
            Stream stream = null;
            string filter = ExcelWorksheets;
            Dispatchers.Main.Invoke(() =>
              {
                  //Gets the Application Type, if true, represents the Desktop application else Web application.
                  if (AutomationFactory.IsAvailable)
                  {

                      SaveFileDialog fileDialog = new SaveFileDialog();
                      fileDialog.Filter = filter;
                      bool? result = fileDialog.ShowDialog();
                      if (result != null && result == true)
                      {
                          stream = fileDialog.OpenFile();
                      }
                      eventHandler.Invoke(stream, new EventArgs());

                  }
                  else
                  {
                      SaveFileWindow saveFile = new SaveFileWindow();
                      saveFile.Filter = filter;
                      saveFile.Closed += eventHandler;
                      saveFile.Show();
                  }
              });
        }
        /// <summary>
        /// Display the Export Succces message box.
        /// </summary>
        public static void ShowSuccessDialog()
        {
            Dispatchers.Main.BeginInvoke(() =>
            {
                    MessageBox.Show("Document has been successfully Saved", "Information", MessageBoxButton.OK);
            });
        }

        
        #endregion 
    }
}
