#region Copyright Syncfusion Inc. 2001-2015.
// Copyright Syncfusion Inc. 2001-2015. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using System;
using System.Linq;
using System.IO;
using System.IO.IsolatedStorage;
using System.Collections.Generic;
using Microsoft.LightSwitch;
using Microsoft.LightSwitch.Framework.Client;
using Microsoft.LightSwitch.Presentation;
using Microsoft.LightSwitch.Presentation.Extensions;
using Syncfusion.LightSwitch.Extension.XlsIO;
namespace LightSwitchApplication
{
    public partial class SpecificFields
    {
        partial void ExportToExcel_Execute()
        {

            Export();
        }
        void Export()
        {
            Helper.ShowSaveDialog(SaveDialog_Closed);
        }
        void SaveDialog_Closed(object sender, EventArgs e)
        {
            SaveFileWindow saveFileWindow = sender as SaveFileWindow;

            if (saveFileWindow != null && saveFileWindow.DocumentStream != null)
            {
                Export(saveFileWindow.DocumentStream);
            }
            else
            {
                Stream stream = sender as Stream;
                if (stream != null)
                {
                    Export(stream);
                }
            }

        }
        public void Export(Stream stream)
        {


            ExportToExcel(stream);
            Helper.ShowSuccessDialog();
        }
        public void ExportToExcel(Stream stream)
        {
            ExcelExportOptions exportSettings = new ExcelExportOptions();
            exportSettings.Worksheet.Application.Worksheets["Sheet1"].Name = "TestExport";
            exportSettings.Mappings.Add(new ColumnMapping("Book Title", "Title"));
            exportSettings.Mappings.Add(new ColumnMapping("Author Name", "Author"));
            exportSettings.Mappings.Add(new ColumnMapping("Category", "Category"));
            exportSettings.Mappings.Add(new ColumnMapping("Rate", "Price"));
            exportSettings.Mappings.Add(new ColumnMapping("Publication Date", "PublicationDate"));
            exportSettings.Mappings.Add(new ColumnMapping("CoverImage", "FrontCoverThumbnail"));
            using (stream)
            {
                ExcelBuilder.Export(this.Books, exportSettings, stream);
            }
        }

    }
}
